Alter PROCEDURE [HM].[hm_RZ_UsunRezerwacjeTbl]
AS

if (select OBJECT_ID('tempdb..#tblDelRZ')) IS NULL
return 0

if not exists (select * from #tblDelRZ)
return 0

declare @return_status int
declare @idrez int

declare @tblSMS TABLE
  (id int, stanHandl decimal(24,6), ilosc decimal(24,6))

insert @tblSMS
select SM.id, SM.stanHandl, RZS.ilosc
from SM join
(select RZ.idtw, RZ.magazyn, (SUM(RZ.iloscrz) - SUM(RZ.iloscrl)) as ilosc
from #tblDelRZ join RZ on #tblDelRZ.id = RZ.id
group by RZ.idtw, RZ.magazyn) as RZS on RZS.idtw = SM.idtw and RZS.magazyn = SM.magazyn

if exists (select * from @tblSMS where (stanHandl + ilosc) < 0.0)
return -4701

	IF (SELECT OBJECT_ID('tempdb..#ChangedDp')) IS NOT NULL
		DROP TABLE #ChangedDp
	CREATE TABLE #ChangedDp (id INT PRIMARY KEY)
	INSERT #ChangedDp
		SELECT distinct RZ.idpozrz
		FROM #tblDelRZ trz
		JOIN RZ ON trz.id = RZ.id
		WHERE 18 = RZ.bazapozrz AND RZ.idpozrz is not null

update SM set stanHandl = cast(SM.stanHandl as decimal(24,6)) + SMS.ilosc
from SM join @tblSMS as SMS on SM.id = SMS.id
set @return_status = @@error
if @return_status <> 0 return @return_status

insert LOCAL_LOG select 'SM', id, 3, @@SPID from @tblSMS
set @return_status = @@error
if @return_status <> 0 return @return_status

declare crzr cursor local FORWARD_ONLY
for select id from #tblDelRZ
open crzr

fetch next from crzr into @idrez
WHILE @@FETCH_STATUS = 0
begin
 exec @return_status = hm_RZ_UsuniecieSkojarzeniaRezerwacji @idrez
 if @return_status <> 0 return @return_status
 fetch next from crzr into @idrez
end

close crzr
deallocate crzr

delete RZ from RZ join #tblDelRZ on #tblDelRZ.id=RZ.id
set @return_status = @@error
if @return_status <> 0 return @return_status

insert LOCAL_LOG select 'RZ', id, 4, @@SPID from #tblDelRZ
set @return_status = @@error
if @return_status <> 0 return @return_status

EXEC hm_DP_PrzeliczZyskKoszt 0, 0
EXEC hm_DP_PrzeliczKosztAproksymowany 0, 0
return 0
GO


